<?php
session_start();
extract($_POST, EXTR_OVERWRITE);
$cookie	= explode(",", $_COOKIE["siteData"]);
$session	=	(object)$_SESSION;
$post = (object)$_POST;
$backend = $cookie[2].$cookie[1];
if(isset($_GET["case"]))$case = $_GET["case"];
if(!isset($_COOKIE['u_vuser'])){setcookie("u_vuser", time(), time()+10*365*24*60*60, '/');}
require_once("{$backend}controllers/Controllers.php");
require_once("{$backend}controllers/Generic.php");
require_once("{$backend}controllers/Messenger.php");
$controller 	= new Generic($cookie[1]);
$uri 	= $controller->getURIdata();
$db   = $controller->connect();
$company	= $controller->company();
switch($case){
	case 1://Verify Pin
		// see($_SESSION);
		$response = new stdClass;
		if(intval($post->token) === intval($session->login)){
			$_SESSION["user_verified"] = true;
			$response->status = 1;
			$response->message = "Welcome to {$company->name}";
			$log = (object)[
				"user_id" => $session->member_id,
				"action" => "Login",
				"location" => "users",
				"submitType" => "insert",
				"type" => "other",
				"description" => "{$session->member_name} Logged In"
			];
			$response = activity($log);
		}else{
			$response = new stdClass;
			$response->status = 0;
			$response->message = "Incorrect Token";
		}
	break;
	case 2://Resend Pin
		require_once($cookie[2].$cookie[1]."controllers/Messenger.php");
		$messenger= new Messenger($controller);
		$messenger->pinAction = empty($post->pinAction) ? "login" : $post->pinAction;
		$k = empty($k) ? $session->member_id : $k;
		$user = $controller->getFromTable("users", "id=$k", 1, 0)[0];
		$response = sendCode($messenger, $user);
	break;
	case 3://Invest
		// Check if paystack
		require_once(absolute_filepath($uri->site)."user/includes/subscriptions.php");
		$response = new stdClass;
		if(!empty($_GET["type"]) && $_GET["type"] === "paystack"){
			$post = $_SESSION["paystack"]["GET"];
			$post->snapshot = "";
			$post->trnx_no = $_GET["reference"];
			extract((array)$post);
			unset($_SESSION["paystack"]);
		}
		$user_id = $session->member_id;
		$plans = $controller->getFromTable("content", "type=investment, status=1", 1, 0);
		$plans = array_values(array_filter($plans, function($plan){
			global $plan_id; return $plan->id == $plan_id;
		}));
		if(count($plans) == 1 || in_array($plan_id, array_keys((array)$subs))){
			$zero = 0;
			if(count($plans) == 1){
				$thisplan = $plans[0];
			}else{
				$thisplan = $subs->{$plan_id};
			}
			$post->amount = intval($post->amount);
			$thisplan->business = intval($thisplan->business);
			if(($post->amount >= $thisplan->business && $post->amount <= $thisplan->label) || $thisplan->business === $post->amount){
				unset($thisplan->body);
				$accountroi = $thisplan->auto;
				$sql = "INSERT INTO tbl_accounts
				(user_id, plan, name, balance, status, paid, date_created, identify, roi, amount, duration)
				VALUES
				(?, ?, ?, ?, 0, 1, now(), ?, ?, ?, ?)";
				$invest = $db->prepare($sql);
				$invest->bind_param('iisssiss', $user_id, $thisplan->id, $thisplan->title, $post->amount, $thisplan->type, $accountroi, $post->amount, $thisplan->view);
				if($invest->execute()){
					$sql = "INSERT INTO tbl_transaction
					(user_id, tx_no, tx_type, amount, description, account_id, paid_into, snapshot, account_details, status)
					VALUES
					(?, ?, ?, ?, ?, ?, ?, ?, ?, 0)";
					$investtr = $db->prepare($sql);
					$company_accounts = json_decode($company->other);
					$company_accounts = $company_accounts[$post->paid_into];
					$post->paid_into 	= $company_accounts->title;
					$post->account_details 	= $company_accounts->desc;
					$post->description= "Payment for {$thisplan->title} Investment";
					$account_id = $db->insert_id;
					$investtr->bind_param('issisisss', $user_id, $post->trnx_no, $post->tx_type, $post->amount, $post->description,$account_id, $post->paid_into, $post->snapshot, $post->account_details);
					if($investtr->execute()){
						activity([
							"user_id" => $session->member_id,
							"action" => "Investment",
							"location" => "tbl_accounts",
							"submitType" => "insert",
							"type" => "other",
							"description" => "{$session->member_name} made payment for {$thisplan->title} Plan"
						]);
						// Send Mail
						$messenger = new Messenger($controller);
						$mail = (object)[
							'subject'=>"New {$company->name} Investment !!!",
							'body'=>"Hi, {$session->member_name},  we just recieved a payment notification of {$post->amount} USD for {$thisplan->title}. \n Please be patient while our team verifies the payment, your investment would be active as soon as the verification is done. Thank you for choosing {$company->name}.",
							'from'=>$company->email,
							'to'=> $session->email,
							'from_name'=>$company->name,
							'to_name'=>$session->member_name,
							'address'=>$company->address,
							'user_id'=>$session->member_id
						];
						$responseEmail = $messenger->sendMail($mail);
						$mail->to = "murphyehibor@gmail.com";
						$mail->to_name = "Murphy";
						$mail->body = "New Payment from {$session->member_name}. Login to View transaction details";
						$responseMail2 = $messenger->sendMail($mail);
						$response->status = 1;
						$response->message = "Your payment for {$thisplan->title} has been recieved";
					}else{
						$response->status = 0;
						$response->message = $db->error;
					}
				}else{
					$response->status = 0;
					$response->message = $db->error;
				}
			}else{
				$response->status = 0;
				$response->message = "Please do not alter the price";
			}
		}else{
			$response->status = 0;
			$response->message = "Investment is currenly unavailable";
		}
		if(!empty($_GET["type"]) && $_GET["type"] === "paystack"){
			header("Location: {$post->self}?payment=success");
		}
		break;
		case 4: //Get Converstion Rates of local currencies and BTC against dollars
		require_once("{$backend}controllers/ForExchange.php");
		$post->local 		= strtoupper($post->local);
		$post->currency = strtoupper($post->currency);
		$post->amount = explode("-", $post->range);
		$exchange = new ForExchange;
		$usdRate  = $exchange->getRate($post->local);
		$btcRate  = $exchange->toBTC();
		$build = [$post->local=>$usdRate, "USD"=>1, "BTC"=>$btcRate];
		foreach ($build as $key => $value) {
			$response[$key] = [round($post->amount[0] * $value, 8), round($post->amount[1] * $value, 8), $value];
		}
		$response["rate"] = $usdRate;
		// Send token for withdrawal
		if(isset($post->action)){
			$responsee = setActionForCode($post);
			$response  = (object)array_merge((array)$responsee, (array)$response);
		}
	break;
	case 5: //Serverside price calculation
		$response = ["value"=> round(($post->amount/$post->rate), 2)];
	break;
	case 6: //Submit Withdrawal Request
		$response = ["value"=> round(($post->amount/$post->rate), 2)];
	break;
	case 7://Authentication token
		$response = setActionForCode($_GET);
		$url = $_GET["redir"];
		header("Location: $url");
		die();
	break;
	case 8://Submit Withdrawal request
	// confirm token
	// see($session);
	if($session->withdrawal === intval($post->token)){
		$account = $controller->getFromTable("tbl_accounts", "id={$post->account_id}, user_id={$session->member_id}");
		if(count($account)){
			$account = $account[0];
			// Validations
			$dollar = "$";
			$proceed = true; $error = "Unsucessful";
			$account->profit = $account->balance - $account->amount;
			if(empty($post->close_account)){//normal withdrawal
				if($post->basemark > $post->amount){
					$proceed = false; $error = "Minimum withdrawal amount is $dollar{$post->basemark}, you may wish to transfer the money to another account";
				}else if($post->amount > $account->profit){
					$proceed = false; $error = "Maximum withdrawal amount is $dollar{$account->profit}";
				}
			}else{//taking your capital
				$post->amount = $account->balance;
				$lockdown_expires  = date("Y-m-d H:i:s", strtotime("+{$account->duration}", strtotime($account->date_created)));
				$maximum_lockdown = date("Y-m-d H:i:s", strtotime("+3 months", strtotime($account->date_created)));
				if(intval(strtotime($lockdown_expires)) > intval(strtotime($maximum_lockdown)))$lockdown_expires = $maximum_lockdown;
				if(strtotime($lockdown_expires) > time()){
					$proceed = false; $error = "You can only take your capital from ".date("Y-m-d", strtotime($maximum_lockdown));
				}
			}
			if($proceed === true){
				$close_account = empty($post->close_account) ? "" : ", status='3'";
				$sql = "UPDATE tbl_accounts SET balance = balance - $post->amount, last_modified=now() $close_account Where id='$post->account_id' AND user_id='{$session->member_id}'";
				if($db->query($sql)){
					$wallet= $controller->getFromTable("content", "user_id={$session->member_id}, id={$post->paid_into}", 1, 1, "", false, ["title","body"])[0];
					$sql = "INSERT INTO tbl_transaction
					(user_id, tx_no, tx_type, amount, description, account_id, paid_into, snapshot, account_details, status)
					VALUES
					(?, ?, ?, ?, ?, ?, ?, ?, ?, 0)";
					$null = null;
					$investtr = $db->prepare($sql);
					$post->paid_into 	= $wallet->title;
					$post->trnx_no = time().rand(1000, 9999);
					$post->account_details 	= $wallet->body;
					$post->description= "Withdrawal of {$post->amount} from {$account->name} Investment";
					$account_id = $account->id;
					$investtr->bind_param('issisisss', $session->member_id, $post->trnx_no, $post->tx_type, $post->amount, $post->description,$account_id, $post->paid_into, $null, $post->account_details);
					if($investtr->execute()):
						$response = ["status"=>1, 'message'=>"{$account->name} withdrawal of $$post->amount is waiting for confirmation"];
						activity([
							"user_id" => $session->member_id,
							"action" => "Withdrawal",
							"location" => "tbl_accounts",
							"submitType" => "insert",
							"type" => 1,
							"description" => "{$session->member_name} Opted for withdrawal of &dollar;$amount"
						]);
					else:
						$response->message = $trxres;
					endif;
				}else{
					$response->message = $db->error;
				}
			}else{
				$response = ["status"=>0, 'message'=>$error];
			}
		}else{
			$response = ["status"=>0, 'message'=>"Please Withdraw from a valid account"];
		}
	}else $response = ["status"=>0, 'message'=>"Invalid Confirmation Token"];
	break;
	default: return(false);
}
$db->close();
echo json_encode($response);
?>
