<?php
	class FormControl{
		static $uri;
		static $paramControl;

		function __construct($uri){
			global $paramControl;
			$this::$uri = $uri;
			$this::$paramControl = $paramControl;
		}

		public function build_form($vt){
			extract($vt);
			$mod_launch= 0;
			if(!empty($coldesc)){
				foreach($coldesc as $_k0 => $v0) { ?>
				 <div class="page">
					<?php foreach($v0 as $_k => $v) {
						if($_k == 'modal'){
							$mod_launch=1;
							$modal_id='mod'.rand();
						}?>
						<div <?php if($_k == 'modal') echo 'class="modal" id="'.$modal_id.'"';else echo 'class="'.trim(explode(' ', $_k)[0]).'desc"' ?>>
						 <?php foreach( $v as $_k1 => $v1) { ?>
					  		<div class="row ">
									<div class="col s12">
										<div class="row card hoverable">
							     		<div class="card-content" >
							     		<?php if(!empty($_k1)) {?>
								     			<div class="card-title black-text"><?=$_k1; ?></div>
											<?php } ?>
											<?php $this->create_elements($vt,$_k0,$_k,$_k1); ?>
								 			</div>
										</div>
									</div>
								</div>
							<?php  }?><?php if($_k=='modal'){?>
								<div class="modal-footer">
						  		<a  class="modal-action blue btn" id='saveModal' >Submit</a>
							  	<a class="modal-action modal-close btn-flat ">Back</a>
						    </div> <?php }?>
							</div>
				    <?php } ?>
			    </div>
		    <?php }
			}
		}

	 public function create_elements($vt, $_k0, $_k, $_k1, $ex=''){
			global $param;
		    extract($vt);
		    $v1 = $coldesc[$_k0][$_k][$_k1];
				foreach($v1 as $_k2=>$desc) {
					$source 	= $src[$_k0][$_k][$_k1][$_k2];
					$class 		= $cls[$_k0][$_k][$_k1][$_k2];
					$multi  	= $mult[$_k0][$_k][$_k1][$_k2];
					$Empty 		= $empty[$_k0][$_k][$_k1][$_k2];
					$Event 		= $event[$_k0][$_k][$_k1][$_k2];
					$Value 		= $value[$_k0][$_k][$_k1][$_k2];
					$Disabled = $disabled[$_k0][$_k][$_k1][$_k2];
					$Readonly = $readonly[$_k0][$_k][$_k1][$_k2];
					$Required = $required[$_k0][$_k][$_k1][$_k2];
					$plh 			= $placeholder[$_k0][$_k][$_k1][$_k2];
					$type 		= strtolower($order[$_k0][$_k][$_k1][$_k2]);
					$name 		= strtolower($columns[$_k0][$_k][$_k1][$_k2]);
					if($type=="text"||$type=="url"||$type=="password"||$type=="date"||$type=="email"||$type=="number"||$type=="hidden" || $type=="button" || $type=="combo" || $type=="textarea" || $type=="checkbox"){ ?>
						<div class="input-field <?=$class; ?>">
							<?php if($type == "textarea" || $type == "button"){?><<?=$type?> <?php }else{?> <input <?php } ?>
									<?php if($Disabled==true) {?> disabled="disabled" <?php }?>
									<?php if($Readonly==true){?>readonly="readonly"<?php } ?>
									<?php if(!empty($Event)){?>
										<?=$Event["type"]?>="<?=$Event["function"]?>"
									<?php }?>
									<?php if($Required==true) { ?>required="required"<?php }?>
									<?php if($type=='number') { ?>step="any"<?php }?>
									<?php if($type=='combo') { ?> display_fields="<?=$multi?>" insert_field = "<?=$Value?>" <?php }?>
									<?php if($type!='combo') { ?>value="<?=$Value?>"<?php }?>
									data-source="<?=$source?>"
									name="<?=$name.$ex; ?>"
									id="<?=$name.$ex; ?>"
									type="<?=$type?>"
									class="filled-in <?="$type $name"?>
									<?php if(strlen($Value) && $type!=='combo') echo 'keep' ?>"
									<?php if(!empty($ex)){ ?>data-class="<?=$name; ?>" <?php }?>
									<?php if(!empty($plh)){ ?>placeholder="<?=$desc?>" <?php }?>
								>
								<?php if($type == "button"){?><?=$Value?><?php }?>
								<?php if($type == "textarea" || $type == "button"){?></<?=$type?>> <?php }else{?> </input> <?php } ?>
								<?php if(empty($plh) && $type !== "button"){?>
									<label class="active" for="<?=$name; ?>"><?php if($Required==true) { ?>*<?php }?><?=$desc; ?></label>
								<?php } ?>
						</div>
					<?php } else if($type=="content") { ?>
						<div class="file-field input-field left <?=$class ?>">
							<label class="active" for="<?=$name; ?>">
								<?php if($Required==true) { ?>*<?php }?><?=$desc; ?>
							</label>
							<div id="<?=$name.$ex; ?>" style="padding-bottom: 20px" class="w-100 input3"><?=$Value; ?></div>
						 </div>
					<?php } else if($type=="file") { ?>
						<div class="file-field input-field left <?=$class ?>">
						  <div
								class="btn generic-file-selector"
								data-href ="<?=$this::$uri->site.$this::$uri->backend?>processors/process_upload.php"
								data-path ="<?=absolute_filepath($this::$uri->site)?>/assets/"
								data-edit ="0"
								data-display ="<?php if(empty($Value)){?> all <?php }else{ echo $Value; } ?>"
								style="height: 2.7rem;line-height: 2.7rem;"
							>
								<span>File</span>
						  </div>
						  <div class="file-path-wrapper">
								<input
									name="<?=$name.$ex; ?>"
									id="<?=$name.$ex; ?>"
									<?php if($Required==true) { ?> required="required" <?php } ?>
									class="file-path validate"
									readonly
									type="text"
									placeholder="<?=$desc; ?>
								">
						  </div>
						</div>
					<?php } else if($type=="select") {?>
						<div class="input-field <?=$class ?>">
							<select
								class="browser-default <?=$name?>"
								data-value="<?=$Value?>"
								data-empty="<?=$Empty?>"
								data-source="<?=$source?>"
								name="<?=$name.$ex; ?>"
								id="<?=$name.$ex; ?>"
								<?php if($multi == true){?> multiple="multiple"	<?php } ?>
								<?php if($Required==true) { ?> required="required" <?php } ?>
								<?php if($Disabled==true) { ?> disabled="disabled" <?php } ?>
								<?php if(!empty($event[$_k0][$_k][$_k1][$_k2])){
									$_selFunc = empty($Event['function']) ? 'heirachy_select(this)': $Event['function'];
									$Event['type'] = empty($Event['type']) ? "onchange" : $Event['type'];?>
									<?=$Event['type']?>="<?=$_selFunc?>"
									data-target="<?=$Event['target']?>"
									data-target-source="<?=$this::$paramControl->source_encode($Event['source'])?>"
									<?php if(!empty($Event['action'])){?> data-target-action="<?=$Event['action']?>"	<?php } ?>
								<?php }?>
							>
							</select>
							<?php if(empty($plh)){?>
								<label class="active" for="<?=$name; ?>"><?php if($Required==true) { ?>*<?php }?><?=$desc; ?></label>
							<?php } ?>
					</div>
				<?php } else if($type=="select_") { ?>
					<div class="input-field <?=$class ?> ">
						<select class="get_ext" <?=$source?> name="<?=$name.$ex; ?>"
							id="<?=$name.$ex; ?>" <?php if($Required==true) { ?> required="required"  class="required" <?php } ?>
							<?php if($Disabled==true) { ?> disabled="disabled" <?php } ?>>
						</select>
						<label for="<?=$name; ?>"><?php if($Required==true) { ?>*<?php }?><?=$desc; ?></label>
				    </div>
			 <?php } else if($type=="switch") { ?>
					<div class="input-field <?=$class ?>">
						 <?php
						 $data = $this::$paramControl->load_data_from_param($source);
						 $vy = [];
						 foreach($data as $_k3=> $v3) { $_ky[]=$_k3; $vy[]=$v3; } ?>
						 <label for="<?=$name; ?>" class="active"><?php if($Required==true) { ?>*<?php }?><?=$desc?></label>
						 <div class="switch" style="height:50px">
							 <label>
									<?php if($Required==true) { ?>*<?php }?> <?=$vy[0]; ?>
									<input
									type='checkbox'
									name="<?=$name.$ex; ?>"
									id="<?=$name.$ex; ?>"
									<?php if($Disabled==true) {?> disabled="disabled" <?php }?>
									<?php if($Readonly==true){?>readonly="readonly"<?php } ?>
									<?php if($Required==true){?>required="required"<?php } ?>>
									<span class="lever"></span>
									<?php if($Required==true) { ?>*<?php }?><?=$vy[1]; ?>
							</label>
				  	</div>
					</div>
				<?php } else if($type=="buttons") {
				 $buttons = $this::$paramControl->load_data_from_param($source);
				 $btnclick = empty($onClick) ? "download" : 'onclick="'.$onClick.'"';
				 foreach ($buttons as $bk => $bv) {?>
					 <div class="<?=$class ?>" style="margin-bottom:10px">
						 <a href="javascript:;" id="<?=$bk?>" name="<?=$bk?>" class="button download" <?=$btnclick?> ><?="$desc $bv"?></a>
					 </div>
				 <?php }
			 	} else if($type=="roles") {
					$pages = 	$this::$paramControl->get_page_param("roles");?>
					<div class="input-field <?=$class ?> role">
						<input type="hidden" name="<?=$name.$ex; ?>" />
		    		<ul class="collection">
				  		<?php
							$parent_id	= 1;
							foreach($pages as $group_name => $group_data ) {?>
								<li>
								  <div class="collection-header ">
									  <input id="<?=$parent_id?>" value="<?=$parent_id?>" type="checkbox" class="rlAll keep">
									  <label for="<?=$parent_id?>" class="collection-header"><?=$group_name?></label>
								  </div>
								  <div class="collection-item">
									  <div class="collection">
											<?php
												$links_id	= 1;
												foreach($group_data->links as $links_key => $links_data){?>
												<div class="collection-item">
													<input class='keep cbr<?=$parent_id?>' type="checkbox" id="<?="{$parent_id}_{$links_id}"?>" value="<?="{$parent_id}:{$links_id}"?>">
													<label class="" for="<?="{$parent_id}_{$links_id}"?>"><?=$links_data->title?></label>
											 </div>
										<?php $links_id++; } ?>
									</div>
								</div>
							</li>
						<?php $parent_id++; } ?>
				  </ul>
				</div>
			 <?php } else if($type=="slave") { ?>
					<div class="slave-container <?= $class?>" data-name="<?=$desc?>" >
						<div class="input-field">
							<div class="checkbox" style="position:relative; width:100%">
								<input
									<?php if($Disabled==true) {?> disabled="disabled" <?php }?>
									<?php if($Readonly==true){?>readonly="readonly" <?php } ?> name="<?=$name.$ex; ?>"
									id="<?=$name.$ex; ?>"
									<?php if($Required==true) { ?>required="required"<?php }?>
									type="checkbox" value="<?=$Value?>"
									class="filled-in <?=$name?> <?php if(strlen($Value))echo 'keep' ?>"
									<?php if(!empty($ex)){ ?>data-class="<?=$name; ?>" <?php }?>
									onclick="toggleSlave(this)"
								/>
								<label for='<?=$name.$ex?>'>Master Stock</label>
							</div>
							<button type="button" class="slave-button hide" onclick="$(this).closest('.slave-container').find('.modal').openModal()">Manage</button>
						</div>
					</div>
				<?php }else if($type=="displaypicture") { ?>
		 			<div class="displaypicture <?= $class?>" data-name="<?=$desc?>" ><img width="100%" name="<?=$name; ?>" id="<?=$name; ?>" src=""></div>
		 		<?php } else if($type=="description") { ?>
					<div class="description-container <?php if($Required==true) echo "required" ?>" data-name="<?=$desc?>" name="<?=$name; ?>">
					</div>
				<?php } else if($type=="items") { ?>
					<div data-num="<?=$Value?>" class="items-container <?php if($Required==true) echo "required ";echo $class ?>" data-desc="<?=$desc?>" name="<?=$name; ?>" >
					</div>
				<?php } else if($type=="json_manager") { ?>
					<div class="json-container <?php if($Required==true) echo "required ";echo $class ?>" data-source="<?=$source?>" data-desc="<?=$desc?>" name="<?=$name;?>" >
					</div>
				<?php } else if($type=="generic-slider") { ?>
					<div class="slider-container <?php if($Required==true) echo "required" ?>" data-name="<?=$desc?>" name="<?=$name; ?>"></div>
				<?php } else if($type=="richtext-body") { ?>
				<div class="richtext-body contentEdittable" name="<?=$name; ?>" id="<?=$name; ?>"></div>
				<?php } else if($type=="richtext-title") { ?>
					<input placeholder="<?=$desc?>" class="richtext-title default" style="font-size:22px" name="<?=$name; ?>" id="<?=$name; ?>">
				<?php } else if($type=="picture") { ?>
					<div class="input-field col s12">
						<a
							href="javascript:;"
							data-href ="<?=$this::$uri->site.$this::$uri->backend?>process/dialog"
							data-path ="<?=absolute_filepath($this::$uri->site)?>assets/"
							class="<?=$name; ?>"
							data-display="picture"
							id="uploadPic"
						>
							<img src="<?php if(isset($col_row[$name]))echo $col_row[$name];else echo $this::$uri->site.$this::$uri->backend.'images/default.png';?>" style="width: 100%;" class='form_pic' data-name="<?=$name; ?>">
							<div class="white black-text center-align valign-wrapper" style="position: absolute; right: 0px; top: 0px; opacity: 0.8; margin-top: 20px;">
								<img class="material-icons black-text medium valign" src="icons/photo_camera.svg">
								<span class="valign"> Click to change picture </span>
							</div>
						</a>
				    <input name="<?=$name; ?>" id="<?=$name; ?>" <?php if($Required==true) { ?> required="required" <?php } ?> hidden="hidden" class="hide" type="text" value="<?php if(isset($col_row[$name]))echo $col_row[$name];?>"/>
					</div>
				<?php }else if($type=="displaypicture") { ?>
					<div class="displaypicture <?= $class?>" data-name="<?=$desc?>" ><img name="<?=$name; ?>" id="<?=$name; ?>" src=""></div>
				<?php  }else if($type == "transactions"){?>
					<div id="_item_div" class="<?=$class?>">
						<div class="col s12">
							<a id="newsales" type="button" onclick="newsales(this)" class="tooltipped newsales" data-tooltip="Add a new transaction row">
								<img src="icons/add.svg" class="btn-floating pink darken-3 btn-flat material-icons" alt="">
							</a>
							<div id="_itemlist" style="display:block" class="table col s12 p-0">
									<?php
									global $params;
									//Extract the source of this transaction widget to create the form attached to it
									$transaction_row = $params->{$source}->form;
									$trans = $this::$paramControl->extract_form($transaction_row);
									$trans_pos = $trans['form_position'];
									foreach($trans["cls"][0][$trans_pos] as $_trans_k => $trans_value) {?>
										<div class="row teal-text lighten-1" data-role="Transaction Header">
											<?php foreach ($trans["cls"][0][$trans_pos][$_trans_k] as $key => $value) {?>
												<div class="<?=$trans["cls"][0][$trans_pos][$_trans_k][$key] ?>" <?php  if( $trans["order"][0][$trans_pos][$_trans_k][$key]=='h') echo 'style="display:none"'; ?>>
													<?=strtoupper($trans["coldesc"][0][$trans_pos][$_trans_k][$key])?>
												</div>
											<?php } ?>
										</div>
										<!-- Transaction body [rows] -->
										<div class="row teal-text lighten-1 desc crv " data-role="Transaction Body" data-num="1">
											<input type="hidden" class="tid" name="tid1" id="tid1" />
											<?php $this->create_elements($trans,0,$trans_pos,$_trans_k,'1'); ?>
										</div>
									<?php } ?>
							</div>
							<input id="sparam" type="hidden" class="keep" value="<?=$this::$paramControl->extractFormSubset($transaction_row, $trans_pos); ?>" />
							<input id="_count" type="hidden" class="keep" value="1" name="num_rows"/>
						</div>
					</div>
					<div class="card-action col s12 exbold no-bottom">
						<div class="col s6 right">
							<input type="text" name="amount" class="col s6 m8 r-align-bold total" readonly="true" autocomplete="off" id="_total"  />
							<label for="_total" class="hide-on-small-only r-label" >TOTAL</label>
						</div>
					</div>
				<?php } ?>
			<?php  }
		}
	}
?>
