<?php
if(session_status() !== 2){ session_start(); }
$post				= array_merge($_GET, $_POST);
$post 			= (object)$post;
$cookie			= explode(",", $_COOKIE["siteData"]);
$session		=	(object)$_SESSION;
require_once($cookie[2].$cookie[1]."controllers/Controllers.php");
require_once($cookie[2].$cookie[1]."controllers/Generic.php");
require_once($cookie[2].$cookie[1]."vendors/paystack/Paystack.php");

// ALL PARAMATERS ARE RECIEVED VIA $_GET or $_POST
/* If you want to save an order first before payment, then add "saveOder" to the GET parameters you are sending to this page and set the value to true;
For this to work, the GET must have these two fields just as in submitForm, to be able to use param submitter
[
	"formName" => NAME_OF_THE_PARAM_YOU_ARE_SUBMITTING_TO,
	"submitType" => "insert",
]
*/
if(!empty($post->saveOder)){
	$controller = new Generic($cookie[1]);
	$uri 				= $controller->getURIdata();
	$response = $controller->submitForm($post);
	if(!$response->status){
		see($response);
	}else{
		// Extracting the content of the response from the sumbition made.
		extract($response);
		// At this point, it's expected that you return the reference id of this transaction as $response->reference
	}
}
// Check for a callbefore function and run it , this is normally used to prepare code before sending to paystack
if(!empty($post->callbefore)){
	$post = call_user_func_array($post->callbefore, [$post]);
}
// Save your variables in a SESSION so that your callback function can retrieve them when it returns
$_SESSION["paystack"] = $post;
// Continue with paystack
$test_key = "sk_test_4fba467e840275332dd958b62b82c70643e0ee3b"; //Clinton's paystack test key
$paystack = new Paystack($test_key);
// the code below throws an exception if there was a problem completing the request,
// else returns an object created from the json response
// This just queries the Paystack server to generate an authorization_url for the payment to initialize
$process_url = empty($post->process_url) ? "{$uri->site}{$uri->backend}process/transaction?posted_from=paystack" : $post->process_url;
// Append GET variables to the callback_url
$_g = explode("?", $process_url);
if(!empty($_g[1])){
	$_gg = explodeToKey("=", explode("&",$_g[1]));
	$_gg["type"] = "paystack";
	$_g[1] = array_serialize($_gg);
	$process_url = "{$_g[0]}?{$_g[1]}";
}
$trx = $paystack->transaction->initialize(
  [
    'amount'=>$post->amount * 100,
    'email'=>$post->email,
    'callback_url'=> $process_url,
  ]
);
// If authorization fails
if(!$trx->status){
  exit($trx->message);
}
// Else proceed to payment interface
header('Location: ' . $trx->data->authorization_url);
