<?php
	require_once "../controllers/Controllers.php";
	require_once "../controllers/FormControl.php";
	//Intstantiate the Generic class
	$cookie		    = explode(",", $_COOKIE["siteData"]);
	$generic 			= new Generic($cookie[1]);
	$get    			= (object)$_GET;
	$uri					= $generic->getURIdata();
	$uri->root    = absolute_filepath("{$uri->site}{$uri->backend}");
	//Pass the generic object into the paramController
	$paramControl = new ParamControl($generic);
	$params    		= $paramControl->get_params();
	$param 				= $params->{$get->pageType};
	$formdata			= $paramControl->extract_form($param->form);
	$formControl	= new FormControl($uri);
	$pageId				= str_replace(' ', '_', $param->page_title);
	global $_color;

?>
<?php if(!empty($get->ajax)) { ?>
	<!DOCTYPE html>
	<html>
		<head>
			<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1" />
			<title><?=$param->page_title ?></title>
			<?php $company = $generic->company(); ?>
			<?php require_once("{$uri->root}includes/link_css.php") ?>
			<?php require_once("{$uri->root}backendProject/link_css.php") ?>
		</head>
		<body>
			<div style="height:2rem;display:block">
				<div class="progress hide">
					<div class="indeterminate"></div>
				</div>
			</div>
		<?php } ?>
		<div class="house" id="_<?=$pageId?>" <?php if(!empty($callback)){?>callback="<?=$callback?>"<?php }?>>
			<?php require_once("{$uri->root}includes/house_container.php") ?>
		</div>

		<!---Generic level first page  ----------->

	<?php if(!empty($param->display_level)) {
		$parent_type  = $param->display_level->source;
		$parent_colum = $param->display_level->column;
		$level 				= $params->{$parent_type};
		$parent_title = str_replace(' ', '_', $level->page_title."_".$pageId);
		$parent_title = "_$parent_title";
		?>
		<div class="house" id="<?=$parent_title?>">
			<div  id="filter_dialog">
				<div class="upload_bar" id="upload_bar">
	      	<div class="top-control row">
						<div class="input-field col l3 s6">
							<input name="toplevel" type="hidden" class="keep" id="_toplevel" value="_<?=$pageId ?>" />
							<input name="pageType" type="hidden" class="keep" id="page_type" value="<?=$parent_type?>" />
							<input name="<?=$get->pageType?>" type="hidden" class="keep" id="hierachy" value="<?=$parent_colum?>" />
							<input name="page_title" type="hidden" class="keep" id="page_title" value="<?=$level->page_title?>" />
							<input name="search" type="text"  id='_searchBox' size="50" value="" />
							<label for="_searchBox">Search <?=$level->page_title?></label>
							<img src="icons/search.svg" class="search prefix material-icons" />
						</div>
						<div class="input-field col l2 s6">
							<select name="range" id='_rangeBox'>
								<option value="">Number of items</option><option value="25">25 Items</option>
								<option value="50">50 Items</option><option value="100">100 Items</option>
								<option value="150">150 Items</option><option value="200">200 Items</option>
							</select>
						</div>
						<div id="_filterList" class="_filterList">
							<input class="filterValue" id='_linkFilter' type="checkbox" checked hidden name="<?=$param->display_level->column ?>" />
							<?php
							if(!empty($level->category)):
								foreach($level->category as $category_key => $category_data) {
									if(isset($category_data->type) && $category_data->type == "period") {?>
										<div class='input-field col m6 l3 right'>
											<input class="dateFilter" type="text" id='<?=$category_data->column?>' size="50" name="<?=$category_data->column?>" />
											<input class="filterValue" type="hidden"  id='_linkFilter'  name="<?=$category_data->column?>" />
											<label class="cat" for='period'>Date Range </label>
										</div>
									<?php } else {
										$kn[]=$category_data;
									}
								}
							endif;
							?>
							<?php if(!empty($kn)) {?>
								<div class="input-field col s6 l3 right">
									<input type="text" id='_filter' size="50" class="filter" data-value="<?=$paramControl->jsonRe_encode($kn)?>"  />
									<label for="_filter">Filter By</label>
								</div>
							<?php } ?>
						</div>
					</div>
				</div>
				<div class="list_cont">
					<div id="dialog_display" class="open_select-div collection with-header" ></div>
				</div>
				<div class="pagination">
					<div id="pagination"></div>
					<input id="active_page" type="hidden" name="page" />
				</div>
			</div>
			<div class="fixed-action-btn" style="bottom: 45px; right: 24px;">
				<a class="btn-floating btn-large grey grey-lighten-2" id="reloadPage" style="padding: 8px;">
					<img class="material-icons" src="icons/refresh.svg">
				</a>
			</div>
		</div>
	</div>
  <script language="javascript" type="text/javascript">
		var firstpage='<?=$parent_title?>';
		formInitialize(firstpage);
		$("#"+pageId).swapDiv($("#"+firstpage));
		$('#_backTop'+pageId).click(function(){
			let parent = $(this).attr("top");
			let current = $(this).data("pageid");
			$("#"+current).swapDiv($("#"+parent+current));
		})
</script>
<?php } ?>
<?php
	if(!empty($get->ajax)) { ?>
	</body>
	</html>
<?php } ?>
