<?php
require_once "../controllers/Controllers.php";
require_once "../controllers/FormControl.php";
//Intstantiate the Generic class
$cookie		    = explode(",", $_COOKIE["siteData"]);
$generic 			= new Generic($cookie[1]);
$get    			= (object)$_GET;
$uri					= $generic->getURIdata();
$uri->root    = absolute_filepath("{$uri->site}{$uri->backend}");
//Pass the generic object into the paramController
$paramControl = new ParamControl($generic);
$params    		= $paramControl->get_params();
$param 				= $params->{$get->pageType};
$formdata			= $paramControl->extract_form($param->form);
$formControl	= new FormControl($uri);
$pageId				= str_replace(' ', '_', $param->page_title);
global $_color;
?>
<?php if(!empty($get->ajax)) { ?>
<!DOCTYPE html>
<html>
  <head>
    <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1" />
    <title><?=$param->page_title ?></title>
    <?php $company = $generic->company(); ?>
    <?php require_once("{$uri->root}includes/link_css.php") ?>
    <?php require_once("{$uri->root}backendProject/link_css.php") ?>
  </head>
  <body>
    <div style="height:2rem;display:block">
      <div class="progress hide">
        <div class="indeterminate"></div>
      </div>
    </div>
    <?php } ?>
    <div class="house" id="_<?=$pageId ?>">
      <?php require_once("{$uri->root}includes/list_view.php") ?>
      <div class="row" id="new_form" style="display:none">
        <!-- The Main form -->
        <div class="col-s12">
          <form id="formData" action="javascript:;" onsubmit="return(false)">
            <div class="form-values">
              <?php if(!empty($param->form_values)){
                foreach ($param->form_values as $key => $value) {?>
                  <input type="hidden" class="keep" id="<?=$key?>" name="<?=$key?>" value="<?=$value?>" />
                <?php }
              } ?>
              <input type="hidden" class="keep" id="page_type" name="pageType" value="<?=$get->pageType?>" />
              <input type="hidden" class="keep" id="page_title" name="page_title" value="<?=$param->page_title?>" />
              <input type="hidden" class="keep" id="trans_no" name="trans_no"/>
              <input type="hidden" name="<?=$param->primary_key?>" id="<?=$param->primary_key?>" value="" />
            </div>
            <?php
              $formControl->build_form($formdata);
            ?>
            <!-- Form Actions -->
            <div class="flt">
              <div class="fixed-action-btn" style="bottom: 45px; right: 24px;">
                <button type="submit" data-position="left" data-delay="50" data-tooltip="Print" class="tooltipped btn-floating btn-large red" id="formPrint">
                  <i class="large material-icons" ><img src="icons/print.svg" /></i>
                </button>
                <ul>
                  <li>
                    <a data-position="left" data-delay="50" data-tooltip="Back" class="tooltipped btn-floating blue" id="close">
                      <i class="material-icons"><img src="icons/reply.svg" /></i>
                    </a>
                  </li>
                  <li>
                    <a data-position="left" data-delay="50" data-tooltip="Reset Form" class="tooltipped btn-floating green" id="formReset"><i class="material-icons"><img src="icons/clear.svg" /></i></a>
                  </li>
                  <li>
                    <button data-position="left" data-delay="50" data-tooltip="Save" class="tooltipped btn-floating pink" id="formSave">
                      <i class="material-icons"><img src="icons/save.svg" /></i>
                    </button>
                  </li>
                </ul>
              </div>
            </div>
          </form>
        </div>
      </div>
    </div>
    <script language="javascript" type="text/javascript">
      var pageId='_<?=$pageId?>';
      formInitialize(pageId);
      transInitialize(pageId);
    </script>
  <?php if(!empty($get->ajax)) { ?>
  </body>
</html>
<?php } ?>
