<?php
require_once("controllers/Generic.php");
require_once("controllers/DateDifference.php");
$generic = new Generic;
$db = $generic->connect();
if(in_array($generic->getServer(), $generic->getLocalServers())){
  $url = "http://localhost/apex/";
}else{
  $url = "https://apexforexglobal.com/";
}
$url = absolute_filepath($url);
require_once("{$url}user/library/user_functions.php");
// // Delete all active investments
// $sql = "DELETE FROM tbl_accounts WHERE status=0 AND paid=0 AND date_created < DATE_SUB(now(), INTERVAL 1 DAY)";
// Get all active investments
$accounts = $generic->getFromTable("tbl_accounts", "status=1, identify=investment", 1, 0);
foreach($accounts as $account){
  //Check if investment duration is still due
  $roi        = caculateROI($account);
  $date       = new DateDifference($account->date_created, date("Y-m-d H:i:s"));
  $stopdate   = date("Ymd", strtotime($roi->stop_date));
  $currdate   = date("Ymd");
  $diff       = intval($date->days());
  if($currdate > $stopdate){
    //Set status to completed
    $db->query("UPDATE tbl_accounts SET status='3' WHERE id='{$account->id}'") or die($db->error);
  }else{
    // Top up after every seven days
    $mod = $diff%7;
    if($mod == 0 && date("Y-m-d", strtotime($account->last_incremented)) != date("Y-m-d")){
      $roi->increase = round($roi->increase, 2);
      $db->query("UPDATE tbl_accounts SET date_modified=now(), balance=balance+{$roi->increase} WHERE id='{$account->id}'") or die($db->error);
      $trnx = [
        "user_id"=>$account->user_id,
        "tx_no"=>md5(time().rand()),
        "tx_type"=>"topup",
        "paid_into"=>"xxxxxxxxxxxxxx",
        "account_details"=>"WALLET",
        "amount"=>$roi->increase,
        "description"=>"Top Up for {$account->name} investment",
        "account_id"=>$account->plan,
        "status"=>1,
      ];
      $trxres = $generic->insert($trnx, "top-ups");
    }
  }
}
die("done");
?>
