<?php

function dashboardWidgets() {
	$arr = [];
	global $db;
	$sql1 = $db->query("select count(cId) as customerCount from customer where type=1");
	$arr['countCustomers'] = $sql1->fetch_assoc();
	$sql2 = $db->query("select count(ref) as orderCount, sum(amount) as total from transactions where sub=0");
	$row = $sql2->fetch_assoc();
	$arr['countOrders'] = $row['orderCount'];
	$arr['totalTrans'] = $row['total'];
	$sql3 = $db->query("select count(tid) as count from item");
	$row3 = $sql3->fetch_assoc();
	$arr['items'] = $row3['count'];
	return json_encode($arr);
}
function display_chart($from,$to){
	global $db;
	$row=[];
	$currentMonth = date('m');
	$currentYear = date('Y');
	$daysInMonth = cal_days_in_month(CAL_GREGORIAN, date('m'), date('Y'));
	// $chartQ = $db->query("select date, amount from transactions where sub=0 and date ");
	$chartQ = $db->query("select distinct date(date) as date, sum(amount) as amount, count(tid) as orders from transactions where sub=0 and  DATE(date) between '$from' and '$to' GROUP BY date ORDER BY date ASC");
	if($chartQ->num_rows){
		while($chartF = $chartQ->fetch_assoc()){
			$chartF['date'] = formatDAte($chartF['date']);
			$row[] = $chartF;
		}
	}
	$chartQ->free();
	return json_encode($row);
}
function inventory(){
		global $db;
		$InventoryQ = $db->query("select * from item");
		$ordersQ = $db->query("select count(sub) from transactions where sub=0");
		$orders_count = $ordersQ->fetch_assoc();
		$lowItems = [];
		if($InventoryQ->num_rows){
			while($ifetch = $InventoryQ->fetch_assoc()){
				if($ifetch['threshold'] >= $ifetch['quantity_on_hand']){
					$item_id = $ifetch['tid'];
					$categories = $db->query("select c.typeid as ctid, c.name as child, p.typeid as pid, p.name as parent, item.tid, item.categories,item.pcategories from category_type c inner join category_type p on p.typeid = c.parent left join item on item.pcategories = p.typeid and item.categories = c.typeid where item.tid = {$item_id}");
					$catFetch = $categories->fetch_assoc();
					$catFetch['cats'] = $catFetch['parent'].' ~ '.$catFetch['child'];
					$catFetch['invent1'] = $ifetch;
					// $lowItems['orders_count'][] = $orders_count;
					$lowItems[] = $catFetch;
				}
			}
		}
			// $InventoryQ->free();
			// $categories->free();
		return json_encode($lowItems);
	}



	// str_replace(search, replace, subject)
	function get_page_identifier_from_url(){
		$request = str_replace(basename(dirname(ROOT)), '', $_SERVER['REQUEST_URI']);
		$parts = explode('/', $request);
		// print_r($parts);die();
		foreach($parts as $key=>$value){
			if(empty($value)){
				unset($parts[$key]);
			}
		}
		if(count($parts) > 1){
			return false;
		}
		$identifier = array_pop($parts);
		if(empty($identifier)){
			$identifier = 'home';
		}
		return $identifier;
	}

	if(isset($_SESSION['SBUser'])){
		$user_id = $_SESSION['SBUser'];
		$uQ = $db->query("SELECT * FROM customer WHERE cid='{$user_id}'");
		$user_data = $uQ->fetch_assoc();
		$fn = explode(' ', trim($user_data['customername']));
		$user_data['first'] = $fn[0];
		if(empty($fn[1])){
			$fn[1] = $fn[0];
		}
		$user_data['last'] = $fn[1];
	}
	function recentOrders() {
		$limit = 20;
		$arr = [];
		$cDate = date("Y-m-d");
		global $db;
		$recentSql = $db->query("select customer, quantity, ref, amount, DATE_FORMAT(date, '%Y-%m-%d') as date from transactions where sub = 0 and DATE(date) = CURDATE()  order by date desc");//
		while($row = $recentSql->fetch_assoc()) {
			$row['date'] = vdate($row['date']);
			$row['amount'] = money($row['amount']);
			$arr[] = $row;
		}
		return json_encode($arr);
	}
?>
