<?php

function processMasterStock($id){
	global $_POST;	global $generic; 	global $param;
	$db = $generic->connect();
	$response = new stdClass;

	$master_cols = ['itemid','upc','categories','pcategories','brand','date_created','created_by','unit','subdivision','price2','sunit_value','sunit'];
	extract($_POST);
	$master_id = $id;
	if(!empty($master_stock_data)){
		$tempData = str_replace("\\", "",$master_stock_data);
		$tempData = utf8ize($tempData);
		$cleanData = json_decode($tempData);
		$subs_id = [];
		if(!empty($cleanData)){
			// loop Through the slave stocks from the form;
			foreach($cleanData as $k => $subItemData){
				$subItemData->price = empty($subItemData->price) ? $price1 : $subItemData->price;
				$thisid = $subItemData->id0.$subItemData->id1;
				$thisid = "$itemid-$thisid";
				$subs_id[] = $thisid;

				//Build query
				$build = "";
				$desc = "$description ({$subItemData->desc0} {$subItemData->title0},{$subItemData->desc1} {$subItemData->title1})";
				$pic = isset($subItemData->picture) ? json_encode($subItemData->picture) : json_encode(array());
				$desc = $db->real_escape_string($desc);
				foreach ($master_cols as $key => $value) {
					if(isset(${$value})){
						$build .= "$value='{${$value}}',";
					}
				}
				$build .= "picture='$pic',description='$desc',price1='{$subItemData->price}',primary_attrib_name='{$subItemData->title0}',substock_primary_attrib_desc='{$subItemData->desc0}',secondary_attrib_name='{$subItemData->title1}',substock_second_attrib_desc ='{$subItemData->desc1}'";

				//check if exists
				$check_slave = "SELECT tid FROM $param->table WHERE slave_stock_id='$thisid' AND master_stock_id='$master_id'";
				$check_query = $db->query($check_slave) or die($db->error);
				//If Existing slave
				if($check_query->num_rows){
					$sql = "UPDATE $param->table SET $build WHERE slave_stock_id='$thisid' AND master_stock_id='$master_id' ";
					$db->query($sql) or die($sql);
				}else{
					//If new slave
					$sql="INSERT INTO $param->table SET $build, slave_stock_id='$thisid',master_stock_id='$master_id'";
					$db->query($sql) or die($db->error." ($sql)");
				}

			}
			$subs_id = implode(',',$subs_id);
			$res = $db->query("DELETE FROM {$param->table} WHERE master_stock_id='$master_id' AND slave_stock_id NOT IN ($subs_id)");
		}
		$res = 1;
	}else if(!empty($delIds)){
		$res = $db->query("DELETE FROM {$param->table} WHERE master_stock_id IN ($delIds)");
	}
	$response->status = $res;
	$response->message = $db->error;
	$response->primary_key = $master_id;
	return $response;
}

function verifyMasterStock($post){
	$tempData = str_replace("\\", "",$post->master_stock_data);
	$tempData = utf8ize($tempData);
	$cleanData = json_decode($tempData);
	$post->is_master_stock = count($cleanData) ? 1 : 0;
	return($post);
}

function signin_log($row, $generic = null){
	global $db;
	if(empty($generic)){
		$cookie		=	 explode(",", $_COOKIE["siteData"]);
		$generic 		= new Generic($cookie[1]);
	}
	$ParamControl = new ParamControl($generic);
	$param 				=	$ParamControl->get_params("log");
	$user 				=	$ParamControl->get_params("admin_signin");
	$_SESSION["loggedin"] = true;
	$_SESSION["user_id"]  =  $row->primary_key;
	$_SESSION["accesslevel"]  =  $row->accesslevel;
	$log = [
		"type"				=>  "admin",
		"action"			=> "login",
		"submitType"	=> "insert",
		"location"		=> $user->table,
		"user_id" 		=> $row->primary_key,
		"description" => "{$row->name_col} signed in"
	];
	$generic->connect();
	$response = $generic->insert($log, $param);
	$generic->closeDB();
	return true;
}

function hash_password($post) {
	$post->password = password_hash($post->password, PASSWORD_DEFAULT);
	return $post;
}
?>
