<?php
session_start();
require_once "controllers/Controllers.php";
require_once "controllers/ParamControl.php";
$backend  = "administrator/";
$session	=	(object)$_SESSION;
$user_id  = (isset($session->user_id)) ? $session->user_id : null;
$auth     = new Auth($user_id, "admin_signin", "$backend");
$param  	= new ParamControl($auth);
$uri 			= $auth->getURIdata(true);
$uri->root= absolute_filepath($uri->site.$uri->backend);
$login		=	$param->get_params("admin_signin");
if(!empty($uri->backend)){
  $uri->page_source = $uri->content_id;
}
if($uri->page_source !== "run_tables"){
  $db 			= $auth->connect();
  $company 	= $auth->company();
  $ext 			= pathinfo($uri->page_source, PATHINFO_EXTENSION);
  $_color   = array("green","yellow darken-4","red","blue darken-3","cyan darken-3","teal darken-4");
  shuffle($_color);
  if(!empty($ext)){
    $url = $_SERVER["REQUEST_URI"];
    $url = str_replace(".$ext","",$url);
    header("Location: $url");
  }
  if(empty($login->interface)){
    die("Go to 'admin_signin' section of param_generic and set the 'interface' paramter as (signin1 or signin2) ");
  }
}
$valid_pages 	= [
	"" 					=> "views/default.php",
	"home" 			=> "views/default.php",
	"index" 		=> "views/default.php",
	"login" 		=> "views/{$login->interface}.php",
	"logout" 		=> "processors/process_logout.php",
  "run_tables"=> "backendProject/database/process_create_tables.php",
  "cron"=> "backendProject/functions/cronjob.php",
];
$page_exists = isset($valid_pages[$uri->page_source]);
if($page_exists == true){
  require_once($valid_pages[$uri->page_source]);
}else{
  die("Htaccess Caught up in admin");
}
if($uri->page_source !== "run_tables"){
  $db->close();
}
?>
