<?php
session_start();
extract($_POST, EXTR_OVERWRITE);
$cookie	= explode(",", $_COOKIE["siteData"]);
if(isset($_GET["case"]))$case = $_GET["case"];
if(!isset($_COOKIE['u_vuser'])){setcookie("u_vuser", time(), time()+10*365*24*60*60, '/');}
require_once($cookie[2].$cookie[1]."controllers/Controllers.php");
require_once($cookie[2].$cookie[1]."controllers/Ecommerce.php");
$controller 	= new Ecommerce($cookie[1]);
$db 	= $controller->connect();
$uri 	= $controller->getURIdata();
$company = $controller->company();
$paramControl= new ParamControl($controller);

switch($case){
	case 1:// Social Share Article
		$sel = $db->query("SELECT title, body, id, type, image from content WHERE id='$article_id'");
		while($row = $sel->fetch_assoc()){
			$data['image'] = json_decode($row['image'],true)[0]['src'];
			$data['body'] = explode('.',strip_tags($row['body']))[0];
			$data['title'] = ucwords($row['title']);
			$data['url'] = $controller->domain."$pageName/$article_id/".str_replace(' ','-', strtolower($row['title']));
		}
		$response = $data;
		break;
	case 1.2:// get captcha
		require_once("captcha.php");
		$response = $_captcha;
		break;
	case 1.3:// send Mail forgot password
		$post = $_POST;
		$auth = new Auth($post, $post["formName"], $cookie[1]);
		$response = $auth->forgotPassword($post);
		break;
	case 1.35:// delete the code sent after 10 mins
		unset($_SESSION["code"]);
		$response = ["status"=>1];
		break;
	case 1.4://update password
		$post = $_POST;
		$auth = new Auth($post, $post["formName"], $cookie[1]);
		$response = $auth->resetPassword($post);
		break;
	case 1.5://Update Cart
		$cart_data = $data;
		$validate_qty = empty($ignore) ? true : false;
		$response = $controller->updateCart($cart_data, $validate_qty);
		break;
	case 1.6://Login
		$post = $_POST;
		$auth = new Auth($post, $post["formName"], $cookie[1]);
		$response = $auth->login($_POST);
		break;
	case 1.7://Submit any Form
		$response = $controller->submitForm($_POST);
		break;
	case 1.8://Manage Shipping Details of a user
		$action = isset($_POST['action']) ? $_POST['action'] : "";
		$response = $controller->manageShippingAddress($_POST, $action);
		break;
	case 2:// All generic backend select elements and Combos
		$result = [];
		foreach($_POST as $id => $arr){
			$saved = $arr_data = $paramControl->source_decode($arr['source']);
			// For fillups
			if(!empty($arr["action"]) && $arr["action"] == "fillup"){
				$param = $paramControl->get_params($arr_data['pageType']);
				$arr_data["retrieve_filter"] = "{$param->primary_key}='{$arr['value']}'";
				$arr_data["usekey"] = true;
			// for hierachy
			}else	if(isset($arr['value']) && isset($arr_data["column"])){
				$arr_data["retrieve_filter"] = "{$arr_data["column"]}='{$arr['value']}'";
				unset($arr_data["column"]);
			}
			$data = $paramControl->load_data_from_param($arr_data);
			if(!empty($arr["action"]) && $arr["action"] == "fillup"){
				$data = array_extract($data[array_keys($data)[0]], explode(",", $saved["column"]), true);
			}
			$result[$id] = $data;
		}
		$response = $result;
	break;
	case 3:// update no of views
		$folder_name = strToFilename($folder_name);
		$views_file = "../../cache/$folder_name/views/{$id}.json";
		$read_file = "../../cache/$folder_name/read/file$id.json";
		//Increment Read File Views
		if(file_exists($read_file)){
			$read = _readFile($read_file);
			$data = json_decode($read);
			$boosted = intval($data->no_of_views) + 1;
			$data->no_of_views = $boosted;
			_writeFile($read_file, $data);
		}
		if(file_exists($views_file)){
			$read = _readFile($views_file);
			$read = intval($read) + 1;
		}else{
			$read = 1;
		}
		_writeFile($views_file, $read);
		$response = ["views"=>$read];
		break;
	case 4://Load comments
		$comments = $controller->getFromTable("conversation", "post_id=$post_id", 1, 8, TIME_DESC);
		$resort = [];
		$count = count($comments);
		foreach ($comments as $key => $value) {
			$timediff = new DateDifference($comments[$key]->time, date("Y-m-d H:i:s"));
			$comments[$key]->time = $timediff->smart();
			$resort[$count] = $comments[$key];
			$count--;
		}
		$response = $resort;
	break;
	case 4.2://Insert Comment
		$build = $response= [];
		$post = (object)$_POST;
		$table = "conversation";
		$post->type = "comment";
		$fields = $controller->getTableFields($table);
		$db =  $controller->connect();
		foreach ($post as $key => $value) {
			if(array_search(strtolower($key), $fields) !==false){
				$v=$db->real_escape_string($value);
				$build[] = "$key='{$v}'";
			}
		}
		$build = implode(",", $build);
		$sql = "INSERT INTO $table SET $build";
		$query = $db->query($sql);
		if(!empty($query)){
			$response["status"] = 1;
			$response["message"] = "Done";
		}else {
			$response["status"] = 0;
			$response["message"] = $db->error;
		}
	break;
	default: return(false);
}
$db->close();
echo json_encode($response);
?>
