<?php
	//Submits all Forms to the database
	session_start();
	require_once "../controllers/Controllers.php";
	$json					=	array();
	$response			= new stdClass;
	$post					= (object)$_POST;
	$session			= (object)$_SESSION;
	$cookie		    = explode(",", $_COOKIE["siteData"]);
	$generic 	    = new Auth($session->user_id, "admin_signin", $cookie[1]);
	$uri					= $generic->getURIdata();
	$paramControl = new ParamControl($generic);
	$param 				= $paramControl->get_params($post->pageType);
	$user					= $generic->user();
	$post->formName = $post->pageType;
	//Redirect to another process page or set submitType to run on current page
	if($user->accesslevel > 2):
		if(isset($param->process_url) && $param->process_url !=="process_generic.php"):
			header($param->process_url);
			die();
		elseif(!empty($post->{$param->primary_key})):
			$post->submitType = "update";
		else:
			$post->submitType = "insert";
			if(isset($post->{$param->primary_key}))unset($post->{$param->primary_key});
		endif;
		// Run the insertion
		$response = $generic->submitForm($post);
		if($response->status):
			//Get the first column name to use it for logging description
			$title = $param->form->sections[0]->section_elements[0]->column;

			//Build logging query
			$action = $post->submitType =='update' ? "edited" : "created";
			$descr 	= (gettype(strpos($post->{$title}, '[{')) === 'boolean') ? "{$post->{$title}} in" : "";
			$descr	=	"{$user->name_col} $action $descr {$post->page_title}";
			if($action === "edited")$descr = $descr."(id:{$post->{$param->primary_key}})";
			$descr 	= substr($descr, 0, 240);

			$logger = (object)[
				"user_id" 	=> $user->primary_key,
				"action" 		=> $action,
				"location"	=> $param->table,
				"submitType"=> "insert",
				"type" 			=> "admin",
				"description" => $descr
			];
			$logParam = $paramControl->get_params("log");
			$generic->insert($logger, $logParam);
		endif;
	else:
		$response->status = 0;
		$response->message = "You have no access to perform this operation";
	endif;
	echo json_encode($response);
?>
