<?php
 $productpage = array_filter($valid_pages, function ($value) {
   return $value == "views/detail.php" || $value == "views/products.php";
 });
 $productpage = array_keys($productpage);
 $homepage = ["home", "index", ""];
?>
<a href="#" class="js-colorlib-nav-toggle colorlib-nav-toggle"><i class="white-text"></i></a>
<header class="stick-nav">
  <figure>
    <img class="w-100" src="<?=$company->logo_ref?>" alt="<?=$company->name?>">
  </figure>
</header>
<aside id="colorlib-aside" role="complementary" class="js-fullheight">
  <h1 id="colorlib-logo">
    <a href="<?=$uri->site?>home">
      <figure class="p-2">
        <img src="<?=$company->logo_ref?>" class="w-100" alt="<?=$company->name?> Logo">
      </figure>
      <figure class="p-2 favicon">
        <img src="<?=$company->favicon?>" class="w-100" alt="<?=$company->name?> Logo">
      </figure>
    </a>
  </h1>

  <nav id="colorlib-main-menu" role="navigation">
    <ul>
      <li class="<?php if(in_array($uri->page_source, $homepage)){?>colorlib-active<?php }?>"><a href="<?=$uri->site?>index">Home</a></li>
      <li class="<?php if(in_array($uri->page_source, $productpage)){?>colorlib-active<?php }?>"><a href="<?=$uri->site?>products">Products</a></li>
      <li class="<?php if($uri->page_source == "contact"){?>colorlib-active<?php }?>"><a href="<?=$uri->site?>contact">Get in Touch</a></li>
    </ul>
  </nav>

  <div class="colorlib-footer">
    <ul>
      <li><a href="tel:<?=$company->phone?>"><i class="icon-phone"></i><?=$company->phone?></a></li>
    </ul>
    <p class="text-white"><small>&copy;Copyright &copy;<?=date("Y")?> <?=ucwords($company->name)?></small></p>
    <ul>
      <li><a href="#"><i class="icon-facebook2"></i></a></li>
      <li><a href="#"><i class="icon-twitter2"></i></a></li>
      <li><a href="#"><i class="icon-instagram"></i></a></li>
      <li><a href="#"><i class="icon-linkedin2"></i></a></li>
    </ul>
  </div>

</aside>
