<?php
session_start();
require_once "administrator/controllers/Controllers.php";
$session	=	(object)$_SESSION;
$generic  = new Generic("administrator/");
$uri 			= $generic->getURIdata(true);
$db 			= $generic->connect();
$company 	= $generic->company();
$ext 			= pathinfo($uri->page_source, PATHINFO_EXTENSION);
$uri->root= absolute_filepath($uri->site.$uri->backend);
if(!empty($ext)){
  $url = $_SERVER["REQUEST_URI"];
  $url = str_replace(".$ext", "", $url);
  header("Location: $url");
}
$valid_pages 	= [
	"" 					=> "views/index.php",
	"home" 			=> "views/index.php",
	"index" 		=> "views/index.php",
	"products" 		=> "views/products.php",
  "detail"     => "views/detail.php",
  "about"     => "views/about.php",
  "services"     => "views/services.php",
  "contact"     => "views/contact.php",
];

	$products = $generic->getFromTable("content", "type=product, status=1", 1, 0, DATE_UPLOADED_DESC);
	$products = array_map(function($product){
    global $valid_pages;
    $url = strToUrl("{$product->id} {$product->title}");
    $valid_pages[$url] = "views/detail.php";
		$product->image = json_decode($product->image);
		return$product;
	}, $products);

$page_exists = isset($valid_pages[$uri->page_source]);
if($page_exists == true){
  require_once($valid_pages[$uri->page_source]);
}else{
  require_once("views/404.php");
}
$db->close();
?>
