<!DOCTYPE HTML>
<html>
	<head>
	<meta charset="utf-8">
	<meta http-equiv="X-UA-Compatible" content="IE=edge">
	<title><?=$company->name?> | Contact Us</title>
	<?php require 'includes/meta.php'; ?>
	<?php require 'includes/links.php'; ?>

	</head>
	<body>
	<div id="colorlib-page">
		<?php require 'includes/sidenav.php'; ?>

		<div id="colorlib-main">

			<div class="colorlib-contact">
				<div class="colorlib-narrow-content">
					<div class="row">
						<div class="col-md-12 animate-box" data-animate-effect="fadeInLeft">
							<span class="heading-meta">Contacts</span>
						</div>
					</div>
					<div class="row">
						<h2 class="colorlib-heading col-md-12">Instant Connect</h2>
						<div class="col-md-6">
							<div class="colorlib-feature colorlib-feature-sm animate-box" data-animate-effect="fadeInLeft">
							<div class="colorlib-icon">
								<i class="icon-mail"></i>
							</div>
							<div class="colorlib-text">
								<p>
									<b>Send Us an Email</b>
								</p>
								<p><a href="mailto:<?=$company->email?>"><?=$company->email?></a></p>
							</div>
						</div>
						</div>
						<div class="col-md-6">
							<div class="colorlib-feature colorlib-feature-sm animate-box" data-animate-effect="fadeInLeft">
							<div class="colorlib-icon">
								<i class="icon-whatsapp"></i>
							</div>
							<div class="colorlib-text">
								<p>
									<b>Chat on Whatsapp</b>
								</p>
								<p><a href="whatsapp://send?text=Hi&phone=<?=$company->phone?>"><?=$company->phone?></a></p>
							</div>
						</div>
						</div>
						<div class="col-md-6">
							<div class="colorlib-feature colorlib-feature-sm animate-box" data-animate-effect="fadeInLeft">
							<div class="colorlib-icon">
								<i class="icon-phone"></i>
							</div>
							<div class="colorlib-text">
								<p>
									<b>Call Center</b>
								</p>
								<p><a href="tel:<?=$company->phone?>"><?=$company->phone?></a></p>
							</div>
						</div>
						</div>
						<div class="col-md-6">
							<div class="colorlib-feature colorlib-feature-sm animate-box" data-animate-effect="fadeInLeft">
							<div class="colorlib-icon">
								<i class="icon-map"></i>
							</div>
							<div class="colorlib-text">
								<p>
									<b>Address</b>
								</p>
								<p><?=$company->address?></p>
							</div>
						</div>
						</div>
						<div class="col-md-12">
							<h2 class="colorlib-heading">Branch Offices</h2>
							<div class="animate-box" data-animate-effect="fadeInRight">
								<div class="fancy-collapse-panel">
									<div class="panel-group row" id="accordion" role="tablist" aria-multiselectable="true">
										<?php foreach (json_decode($company->other) as $key => $value) {?>
											<div class="panel panel-default col-md-6">
												<div class="panel-heading" role="tab" id="heading<?=$key?>">
														<h4 class="panel-title">
																<a class="collapsed" data-toggle="collapse" href="#collapse<?=$key?>" aria-controls="collapse<?=$key?>"><?=$value->title?>
																</a>
														</h4>
												</div>
												<div id="collapse<?=$key?>" class="panel-collapse collapse in" role="tabpanel" aria-labelledby="heading<?=$key?>">
													 <div class="panel-body">
														<p><?=$value->desc?></p>
													</div>
												</div>
											</div>
										<?php } ?>
								</div>
							</div>
						</div>

						</div>
					</div>
				</div>
			</div>
		</div>
	</div>
<?php require 'includes/footer.php'; ?>

	</body>
</html>
