<?php
$id = explode("-", $uri->page_source)[0];
$product = $generic->getFromTable("content", "id=$id");
$product = $product[0];
$product->image = json_decode($product->image);
// Get random related
$related  = array_columnn($products, "id");
$products = array_remap($products, $related);
$filtered = array_diff($related, [$id]);
$random   = array_rand($related, 3);
$related  = array_extract($products, array_extract($filtered, $random));
$db->query("UPDATE content SET no_of_views = no_of_views + 1 WHERE id={$product->id}")
?>
<!DOCTYPE HTML>
<html>
	<head>
	<meta charset="utf-8">
	<meta http-equiv="X-UA-Compatible" content="IE=edge">
	<title><?=$company->name?> | <?=ucwords($product->title)?> Details</title>
	<?php require 'includes/meta.php'; ?>
	<?php require 'includes/links.php'; ?>

	</head>
	<body>
	<div id="colorlib-page">
		<?php require 'includes/sidenav.php'; ?>

		<div id="colorlib-main">

			<div class="colorlib-about">
				<div class="colorlib-narrow-content">
					<div class="row row-bottom-padded-md">
						<div class="col-md-6 col-lg-5">
							<div class="slide-one-item home-slider owl-carousel animated fadeInUp" id="item-slider">
								<?php foreach ($product->image as $key => $picture) {?>
									<div>
										<img src="<?=$picture->src?>" alt="<?=$picture->title?>" class="img-fluid">
										<title class="d-block"><?=$picture->title?></title>
									</div>
								<?php } ?>
							</div>
						</div>
						<div class="col-md-6 col-lg-7 animate-box" data-animate-effect="fadeInLeft">
							<div class="about-desc">
								<span class="heading-meta"><?=$product->label?></span>
								<h2 class="colorlib-heading"><?=$product->title?></h2>
								<p>
									<?=$product->body?>
								</p>
							</div>
							<div class="row">
								<div class="col-md-12 animate-box" data-animate-effect="fadeInLeft">
									<a href="whatsapp://send?text=<?=urlencode("Hi, i want to make enquiries about {$product->title}")?>&phone=+234<?=substr($company->phone,1 ,10)?>" class="btn btn-primary btn-learn float-left">Contact Seller!</a></p>
								</div>
							</div>
							<div class="row padding">
								<div class="col-md-4 no-gutters animate-box" data-animate-effect="fadeInLeft">
									<a href="#" class="steps active">
										<p class="icon"><span><i class="icon-check"></i></span></p>
										<h3>We are <br>pasionate</h3>
									</a>
								</div>
								<div class="col-md-4 no-gutters animate-box" data-animate-effect="fadeInLeft">
									<a href="#" class="steps">
										<p class="icon"><span><i class="icon-check"></i></span></p>
										<h3>Honest <br>Dependable</h3>
									</a>
								</div>
								<div class="col-md-4 no-gutters animate-box" data-animate-effect="fadeInLeft">
									<a href="#" class="steps">
										<p class="icon"><span><i class="icon-check"></i></span></p>
										<h3>Always <br>Improving</h3>
									</a>
								</div>
							</div>

						</div>
					</div>

					<hr>
					<div class="row">
						<h2 class="colorlib-heading col-md-12">You may also like</h2>
						<?php foreach($related as $key => $item){$url = strToUrl("{$item->id} {$item->title}")?>
							<div class="col-md-4">
								<a href="<?=$uri->site.$url?>" class="services-wrap animate-box" data-animate-effect="fadeInRight">
									<div class="services-img" style="background-image: url('<?=$item->image[0]->src?>')"></div>
									<div class="desc">
										<h3><?=$item->title?></h3>
									</div>
								</a>
							</div>
						<?php } ?>
					</div>
				</div>
			</div>

		</div>
	</div>
<?php require 'includes/footer.php'; ?>
	</body>
</html>
