<?php
	$products = $generic->getFromTable("content", "type=product, status=1", 1, 3, NO_OF_VIEWS_DESC);
	$products = array_map(function($product){
		$product->image = json_decode($product->image);
		return $product;
	}, $products);
?>
<!DOCTYPE HTML>
<html>
	<head>
	<meta charset="utf-8">
	<meta http-equiv="X-UA-Compatible" content="IE=edge">
	<title><?=$company->name?> | Home</title>
	<?php require 'includes/meta.php'; ?>
	<?php require 'includes/links.php'; ?>

	</head>
	<body>
	<div id="colorlib-page">
		<?php require 'includes/sidenav.php'; ?>
		<div id="colorlib-main">
			<aside id="colorlib-hero" class="js-fullheight">
				<div class="flexslider js-fullheight">
					<ul class="slides">
				   	<?php foreach ($company->slider as $key => $slider) {?>
							<li style="background-image: url('<?=$slider->src?>');">
					   		<div class="overlay"></div>
					   		<div class="container-fluid">
					   			<div class="row">
						   			<div class="col-md-6 col-md-offset-3 col-md-push-3 col-sm-12 col-xs-12 js-fullheight slider-text">
						   				<div class="slider-text-inner">
						   					<div class="desc">
							   					<h1><?=$slider->title?></h1>
							   					<h2><?=$slider->desc?></h2>
													<?php if(!empty($slider->anchor_name)){?>
														<p>
															<a href="<?=$slider->anchor_href?>" class="btn btn-primary btn-learn">
																<?=$slider->anchor_name?>
																<i class="icon-arrow-right3"></i>
															</a>
														</p>
													<?php } ?>
												</div>
						   				</div>
						   			</div>
						   		</div>
					   		</div>
					   	</li>
				    <?php	} ?>
				  	</ul>
			  	</div>
			</aside>

			<div class="colorlib-about">
				<div class="colorlib-narrow-content">
					<div class="row">
						<div class="col-md-6">
							<div class="about-img animate-box" data-animate-effect="fadeInLeft" style="background-image: url('assets/picture/duluxe (3).jpeg');">
							</div>
						</div>
						<div class="col-md-6 animate-box" data-animate-effect="fadeInLeft">
							<div class="about-desc">
								<span class="heading-meta">Welcome</span>
								<h2 class="colorlib-heading">Who we are</h2>
								<p>Duluxe1 Lubricants was established in 2015 with the basic intention of manufacturing and marketing of various lubricants and automotive fluids.
									<br>We produce a wide range of synthetic and conventional engine oils, ATFs and other essential lubricants.<br>
Duluxe1 plant is based in the United States of America, with subsidiaries in Other parts of the world, including Africa. </p>

<p>We recommended Duluxe1 Lubricants because the company has the growing need of the transport industry in mind and produces high quality lubricants to prolong the life of vehicles by cleaning and protecting their engines.  Duluxe1 Lubricants has consistently improved the performance of its lubricants through the development of our own unique type of synthetic base oil technology combined with innovative additive packages. </p>

<p>Duluxe1 Lubricants aims to play an important role in the world in the development of high quality oil lubricants products portfolio with maximum adherence to the world environmental quality standard protection.</p>
							</div>
							<div class="row padding">
								<div class="col-md-4 no-gutters animate-box" data-animate-effect="fadeInLeft">
									<a href="#" class="steps active">
										<p class="icon"><span><i class="icon-check"></i></span></p>
										<h3>We are <br>pasionate</h3>
									</a>
								</div>
								<div class="col-md-4 no-gutters animate-box" data-animate-effect="fadeInLeft">
									<a href="#" class="steps">
										<p class="icon"><span><i class="icon-check"></i></span></p>
										<h3>Honest <br>Dependable</h3>
									</a>
								</div>
								<div class="col-md-4 no-gutters animate-box" data-animate-effect="fadeInLeft">
									<a href="#" class="steps">
										<p class="icon"><span><i class="icon-check"></i></span></p>
										<h3>Always <br>Improving</h3>
									</a>
								</div>
							</div>
						</div>
					</div>
				</div>
			</div>

			<div class="colorlib-services">
				<div class="colorlib-narrow-content">
					<div class="row">
						<div class="col-md-6 col-md-offset-3 col-md-pull-3 animate-box" data-animate-effect="fadeInLeft">
							<span class="heading-meta">Featured Products</span>
							<h2 class="colorlib-heading">Some of our best selling products</h2>
						</div>
					</div>
					<div class="row row-bottom-padded-md">
						<?php
						 $classes = ["col-md-6", "col-md-3", "col-md-3"];
						 foreach ($products as $key => $product) { require("includes/item.php"); } ?>
					</div>
					<div class="row">
						<div class="col-md-6 col-md-offset-3 col-md-pull-3 animate-box" data-animate-effect="fadeInLeft">
							<a href="<?=$uri->site?>products" class="btn btn-primary btn-learn">See more!</a></p>
						</div>
					</div>
				</div>
			</div>
		</div>
	</div>

	<?php require 'includes/footer.php'; ?>
	</body>
</html>
